local BattleFuncSet = false
local threshold1 = 6
local threshold2 = threshold1+35
local state_charging = 1
local state_energyblast = 2
local state_dashslicer = 3
local cooldownlength = 7*TICRATE/2
local sideangle = ANG15/4 //Horizontal spread
local vertwidth = ANG15/2 //Vertical spread
local blastcount1 = 3
local blastcount2 = 5

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true
	
	CBW_Battle.Action.DetnEnergyAttack_Priority = function(player)
		if player.actionstate == state_charging then
			CBW_Battle.SetPriority(player,1,1,nil,1,1,"energy charge aura")
		end
	end

	CBW_Battle.Action.DetnEnergyAttack=function(mo,doaction,throwring,tossflag)
		local player = mo.player
		if P_PlayerInPain(player)
			player.actionstate = 0
		end
		
		if not(CBW_Battle.CanDoAction(player) or player.actionstate >= state_dashslicer)
		return end
			
		//Action info
		player.actiontext = "Energy Attack"
		player.actionrings = 10
		player.actiontime = $+1
		if player.exhaustmeter < FRACUNIT and player.actionstate == 1 then
			player.action2text = "Overheat "..100*player.exhaustmeter/FRACUNIT.."%"
		end
		
		//Action triggers
		local attackready = (player.actiontime >= threshold1 and player.actionstate == state_charging)
		local charging = player.exhaustmeter and ((CBW_Battle.PlayerButtonPressed(player,player.battleconfig_special,true) or not(attackready)) and player.actionstate == state_charging)
		local blasttrigger = (attackready and doaction == 0 and attackready)
		local slashtrigger = (attackready and CBW_Battle.PlayerButtonPressed(player,BT_SPIN,false))
		local chargehold = (attackready and CBW_Battle.PlayerButtonPressed(player,player.battleconfig_special,true))
		local dashtrigger = (attackready and doaction == 2 and CBW_Battle.PlayerButtonPressed(player,BT_JUMP,false))
		local canceltrigger = (player.actionstate == state_charging and doaction == 2
			and (player.exhaustmeter == 0 or CBW_Battle.PlayerButtonPressed(player,player.battleconfig_guard,false)))
		local chargetrigger = (player.actionstate == 0 and doaction == 1)
		
		//Intercepted while charging
		if (player.actionstate == state_charging or player.actionstate == state_energyblast) and player.powers[pw_nocontrol] then
			player.actionstate = 0
			CBW_Battle.ApplyCooldown(player,cooldownlength)
			return
		end
		
		//Start charging blast
		if chargetrigger
			CBW_Battle.PayRings(player,player.actionrings)
			player.actionstate = 1
			player.actiontime = 0
			player.exhaustmeter = FRACUNIT
			if player.dashmode >= TICRATE*3 then
				player.actiontime = threshold1
			end
			S_StartSound(mo,sfx_s3k7a)
			local a = P_SpawnMobj(mo.x,mo.y,mo.z,MT_ENERGYAURA)
			if a and a.valid then 
				a.target = mo
			end
		end
		
		//Charging Blast
		if charging then
			//Do aim sights
			CBW_Battle.DrawAimLine(player,mo.angle)
			if player.actiontime > threshold2
				CBW_Battle.DrawAimLine(player,mo.angle+sideangle*(blastcount2>>1))
				CBW_Battle.DrawAimLine(player,mo.angle-sideangle*(blastcount2>>1))
			end
	-- 		player.pflags = $|PF_STASIS
	-- 		player.lockmove = true
			player.pflags = $|PF_JUMPSTASIS
			player.exhaustmeter = max(0,$-(FRACUNIT/35/6))
			//Gather spheres
			local gather = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_ENERGYGATHER)
			if gather and gather.valid then
				gather.target = mo
				gather.fuse = 35
				gather.extravalue1 = P_RandomRange(0,359)*ANG1
				gather.extravalue2 = P_RandomRange(0,359)*ANG1
				gather.scale = mo.scale/4
			end
			
			//Speed Cap
			local speed = FixedHypot(mo.momx,mo.momy)
			if speed > mo.scale then
				local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
				P_InstaThrust(mo,dir,speed-mo.scale)
			end
			//Blast Powerup
			if chargehold then
				if not(player.actiontime&3)
					then
					S_StartSound(mo,sfx_s3k5c)
					P_SpawnThokMobj(player)
				end
				if player.actiontime == threshold2 then
				S_StartSound(mo,sfx_s1c3)
					for l = 0,8
						P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_NIGHTSPARKLE,mo.angle+45*l*ANG1,nil,1)
					end
				end
				if player.actiontime >= threshold2 then
					local thok = P_SpawnMobj(mo.x+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.y+P_RandomRange(-mo.radius/FRACUNIT,mo.radius/FRACUNIT)*FRACUNIT,mo.z,MT_THOK)
					if thok and thok.valid then
						thok.scale = $/16
						P_SetObjectMomZ(thok,FRACUNIT*16*8)
						thok.momx = mo.momx
						thok.momy = mo.momy
						thok.color = SKINCOLOR_WHITE
					end
				end
			end
		end
		
		//Dash burst
		if dashtrigger then
			CBW_Battle.ResetPlayerProperties(player,true,true)
	-- 		player.pflags = $|PF_NOJUMPDAMAGE&~PF_JUMPDOWN
			player.pflags = $&~PF_JUMPED
			player.actiontime = -1
			S_StartSound(mo,sfx_zoom)
			mo.state = S_PLAY_RUN
			P_InstaThrust(mo,mo.angle,60*FRACUNIT)
			CBW_Battle.ApplyCooldown(player,cooldownlength)
		end
			
		//Unable to charge
		if canceltrigger then
			CBW_Battle.ResetPlayerProperties(player,false,false)
			player.actiontime = -1
			S_StartSound(mo,sfx_s3k7d)
			CBW_Battle.ApplyCooldown(player,cooldownlength)
		end
		
		//Release blast
		if blasttrigger then
			player.actionstate = 2
			S_StartSound(mo,sfx_s3k54)
			local set = blastcount1
			local decay = 1
			local vset = 2
			local vwidth = vertwidth/2
			if player.actiontime >= threshold2 then
				set = blastcount2
				decay = 0
				vset = 4
				vwidth = vertwidth
			end
			local angle = mo.angle
			//Projectiles
			for i = 1,set
				if i > 1 and i&1 then angle = mo.angle-sideangle*(i>>1) end
				if i > 1 and not(i&1) then angle = mo.angle+sideangle*(i>>1) end
				local m = (vset)
				if i > 1 and decay then m = 0 end
				for n = 0, m
					local blast = P_SPMAngle(mo,MT_ENERGYBLAST,angle,0)
					if blast and blast.valid then
						blast.scale = (mo.scale/400)*(200+player.actiontime)
						local speed = blast.info.speed
						local xyangle = R_PointToAngle2(0,0,blast.momx,blast.momy)
						local zangle
						if m == 0 then zangle = 0
						else zangle = CBW_Battle.FixedLerp(-vwidth,vwidth,FRACUNIT*n/m)
						end
						CBW_Battle.InstaThrustZAim(blast,xyangle,zangle,speed,0)
						if G_GametypeHasTeams() then
							blast.colorized = true
							blast.color = mo.color
						end
					end
				end
			end
			//Apply recoil
			P_InstaThrust(mo,mo.angle+ANGLE_180,6*mo.scale)
			player.actiontime = 0
			CBW_Battle.ApplyCooldown(player,cooldownlength)
		end
		
		//Update states
		if player.actionstate == state_charging then
			mo.state = S_PLAY_ROLL
			player.drawangle = mo.angle
			player.pflags = ($|PF_JUMPED)&~PF_NOJUMPDAMAGE
			P_SetObjectMomZ(mo,FRACUNIT/2,false) //Rise slowly
		elseif (player.actiontime == -1) then
			player.actiontime = 0
		end
		
		//Charge release state
		if player.actionstate == state_energyblast then
			mo.state = S_PLAY_SPRING
	-- 		player.pflags = $|(PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED)&~PF_JUMPDOWN
			player.pflags = $&~PF_JUMPED
			player.exhaustmeter = FRACUNIT
			player.secondjump = 0
			mo.momz = 0
			if player.actiontime > 15 then
				player.actiontime = 0
				player.actionstate = 0
			end
		end

	//-Metal Energy Aura-
	CBW_Battle.MetalAura = function(mo,target)
		if not(target and target.valid and target.player and target.player.actionstate == state_charging
			and target.player.playerstate == PST_LIVE)
			P_RemoveMobj(mo)
		return end
		mo.scale = target.scale
		P_TeleportMove(mo,target.x,target.y,target.z-target.height/4)
	end

	//-Metal Sonic "gather" spheres-
	CBW_Battle.EnergyGather = function(mo,target,xyangle,zangle)
		if not(target and target.valid and target.player and target.player.actionstate == state_charging) then
			P_RemoveMobj(mo)
		return end
		local dist = FRACUNIT*16*mo.fuse
		local xydist = P_ReturnThrustX(nil,zangle,dist)
		local zdist = P_ReturnThrustY(nil,zangle,dist)
		local x = target.x+P_ReturnThrustX(nil,xyangle,xydist)
		local y = target.y+P_ReturnThrustY(nil,xyangle,xydist)
		local z = target.z+zdist+target.height/2
		P_TeleportMove(mo,x,y,z)
	end
	
	end

	CBW_Battle.SkinVars["deton"] = {
		flags = SKINVARS_NOSPINSHIELD,
 		weight = 120,
 		shields = 1,
		special = CBW_Battle.Action.DetnEnergyAttack,
 		guard_enabled = true,
 		guard_frame = 2,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon,
 		func_priority_ext = CBW_Battle.Action.DetnEnergyAttack_Priority
	}
end)