freeslot("sfx_dtnwin", "sfx_dtnbom", "S_PLAY_HYPERTRNS_1", "S_DET_WAIT", "S_DET_WIN", "S_DET_WIN1")
sfxinfo[sfx_dtnbom].caption = "Detonation"
sfxinfo[sfx_dtnwin].caption = "Beeps of joy"

states[S_DET_WAIT] = {SPR_PLAY, SPR2_WAIT, 6, nil, 0, 0, S_DET_WAIT}
states[S_DET_WIN] = {SPR_PLAY, SPR2_FLY_|FF_ANIMATE, 24, nil, 11, 2, S_DET_WIN1}
states[S_DET_WIN1] = {SPR_PLAY, SPR2_GLID, 5, nil, 0, 0, S_DET_WIN1}

local sparks = function(inflictor, ns)
	local i = 0
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa),ns)
			mo.momx = FixedMul(sin(fa),ns)
		end
		i = $+1
	end
end

local jumpnuke = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
		or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
			continue
		end
		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue
		end
		if P_AproxDistance(P_AproxDistance(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end
		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end
		if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
			P_KillMobj(mo, inflictor, source, DMG_NUKE) 
		end
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end	

addHook("PreThinkFrame", function()
	if srb2p return end //stop breaking my persona >:(
	for p in players.iterate
		if p and p.mo
			if (p.mo.skin == "deton") and (p.playerstate == PST_LIVE)			
				//variables
				if p.detonjumped == nil
				or (P_IsObjectOnGround(p.mo))
					p.detonjumped = 0 
					p.armanuke = 0
				end
				
				if p.spedmesur == nil
				or not (P_PlayerInPain(p))
					p.spedmesur = p.speed
					p.dothefunny = 0
				end
				
				if p.detonhold == nil
				or not (p.cmd.buttons & BT_SPIN)
					p.detonhold = 0
				end
				
				if P_IsObjectOnGround(p.mo) 
				and (p.cmd.buttons & BT_SPIN) 
				or p.rings >= 50 and not p.powers[pw_super] and All7Emeralds(emeralds) and (player.powers[pw_shield] & SH_NOSTACK) == SH_NONE //prevent transforming doing a bad
					p.detonhold = 1
				end
				
				//the jump part
				if (p.cmd.buttons & BT_SPIN)
				and p.detonjumped == 0
				and not (P_IsObjectOnGround(p.mo))
				and (p.pflags & PF_JUMPED)
				and p.detonhold == 0
				and not p.powers[pw_carry]
				and not (p.mo.tracer and p.mo.tracer.type == MT_TUBEWAYPOINT)
				and not (p.pflags & PF_THOKKED)
				and not (P_PlayerInPain(p))
				and not (p.exiting)
					p.detonjumped = 1
					p.detonhold = 1
					if p.hovertime != 30
						p.hovertime = 0
					end
					
					local vinedboombd = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_FADBOOM)
					if p.powers[pw_super]
						vinedboombd.scale = 4*FRACUNIT
					else
						vinedboombd.scale = 2*FRACUNIT
					end
					if p.powers[pw_super] and not p.hyper
						P_SetObjectMomZ(p.mo, 22*FRACUNIT)
						jumpnuke(p.mo, p.mo, 240*FRACUNIT)
					elseif p.hyper and p.hyper.capable and p.powers[pw_super]
						P_SetObjectMomZ(p.mo, (p.speed / 7) + 25*FRACUNIT)
						jumpnuke(p.mo, p.mo, 500*FRACUNIT)
						S_StartSound(p.mo, sfx_brakrx)
						P_FlashPal(p, PAL_NUKE, 10)
					else
						P_SetObjectMomZ(p.mo, 17*FRACUNIT)
						jumpnuke(p.mo, p.mo, 170*FRACUNIT)
					end
					if (p.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON //WHAT HAVE YOU DONE
						P_SetObjectMomZ(p.mo, 5*FRACUNIT, true)
						P_NukeEnemies(p.mo, p.mo, 900*p.mo.scale)
						P_FlashPal(p, PAL_NUKE, 10)
						p.powers[pw_shield] = SH_NONE
						S_StartSound(p.mo, sfx_bkpoof)
						P_StartQuake(20*FRACUNIT, 5)
						P_InstaThrust(p.mo, p.mo.angle, (10*p.mo.scale + p.speed))
						p.armanuke = 1
					end
					if p.mo.eflags & MFE_UNDERWATER
						p.mo.momz = $*3/5
					end
					p.pflags = $1 & ~PF_JUMPED
					p.pflags = $1 & ~PF_SPINNING
					sparks(p.mo, 10 << FRACBITS)
					S_StartSound(p.mo, sfx_dtnbom)
					p.mo.state = S_PLAY_SPRING
				end
				
				if leveltime % 2 == 0 and p.armanuke == 1
					P_SpawnMobj(p.mo.x + (P_RandomRange(-32,32)*p.mo.scale),p.mo.y + (P_RandomRange(-32,32)*p.mo.scale),p.mo.z + (P_RandomRange(-3,32)*p.mo.scale),MT_TNTDUST)
				end
				if (p.mo.eflags & MFE_UNDERWATER) or (p.mo.eflags & MFE_GOOWATER)
				or p.powers[pw_carry] or (P_PlayerInPain(p))
					p.armanuke = 0
				end
				
				//extra waits
				if p.mo.state == S_PLAY_WAIT
				and p.speed == 0
					p.mo.state = S_DET_WAIT
				end
				
				if p.speed != 0
				and p.mo.state == S_DET_WAIT
				and P_IsObjectOnGround(p.mo)
					p.mo.state = S_PLAY_WALK
				end
				
				//uhhh
				if p.dothefunny == 1
					P_SetObjectMomZ(p.mo, 4*FRACUNIT, true)
					P_InstaThrust(p.mo, p.mo.angle, p.spedmesur)
					p.powers[pw_flashing] = 0
					p.mo.state = S_PLAY_SPRING
					p.dothefunny = 0
				end
				
				if not p.exiting
				or p.dothepose == nil
					p.dothepose = false
				end
				
				if p.exiting
				and p.dothepose == false
				and p.mo.state == S_PLAY_STND
					p.mo.state = S_DET_WIN
					S_StartSound(p.mo, sfx_dtnwin)
					p.dothepose = true
				end
				
			end
			if p.mo.state == S_DET_WAIT
			and (p.mo.skin != "deton")
				p.mo.state = S_PLAY_STND
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "deton")
	and player.playerstate == PST_LIVE 	

		//measure jumps
		if player.hovnum == nil 
			player.hovnum = 0 
			player.justjumped = 0
			player.jumpcheck = 0
		end
		if player.squashtime == nil
			player.squashtime = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and player.jumpcheck == 0 
			player.hovnum = 0 
		end
		
		//to prevent the thing
		if player.usedown == nil 
		or not (player.cmd.buttons & BT_JUMP) 
			player.usedown = 0
			player.justjumped = 0 
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_JUMP) 
			player.usedown = 1 
		end
	
				
		//---------------------------------------------------------------------
		
		if (player.pflags & PF_JUMPED or not (player.pflags & PF_JUMPED) and player.detonjumped == 1)
		and player.usedown == 0 
		and not (player.pflags & PF_THOKKED) 
		and player.cmd.buttons & BT_JUMP 
		and player.jumpcheck == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
			player.jumpcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (player.pflags & PF_STARTDASH) 
		and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
		and player.jumpcheck == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		or player.jumpcheck == 1
		and not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_THOKKED)
			
			//first jump
			if player.hovnum == 0 
				player.justjumped = 1 
				player.hovnum = 1 //you just jumped weenie congrats
			end
			
			//second jump
			if player.hovnum == 1 
			and player.justjumped == 0 
			and not (P_PlayerInPain(player)) 
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not P_IsObjectOnGround(player.mo)
				player.activatedethover = 1 
				player.justjumped = 1 
				player.hovnum = 2 
				player.mo.state = S_PLAY_FLOAT
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $|PF_JUMPED
				S_StartSound(player.mo, sfx_s3k86)
			end
			player.jumpcheck = 0
			player.usedown = 1 	
		end
		
		if not (player.cmd.buttons & BT_SPIN) then -- boolean for explosions
			player.cantap = true
			player.tapspin = false
		elseif player.cantap then
			player.tapspin = true
			player.cantap = false
		else
			player.tapspin = false
		end
		
		if player.activatedethover == 1
			//the funky dash
			if player.hovertime != 0
			and	not (player.pflags & PF_SPINNING) 
			and not (player.pflags & PF_STARTDASH) 
			and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
			and player.mo.health 
			and not (P_PlayerInPain(player)) 
				player.hovertime = $-1
				player.hovnum = 2
				if not (player.mo.eflags & MFE_SPRUNG)
					player.mo.momz = 0
					if player.tapspin //okay its REALLY stupid to copy-paste this but it works!!!!
					and player.detonjumped == 0
						player.hovertime = 0
						local vinedboombd = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FADBOOM)
						if player.powers[pw_super]
							vinedboombd.scale = 4*FRACUNIT
						else
							vinedboombd.scale = 2*FRACUNIT
						end
						if player.powers[pw_super] and not player.hyper
							P_SetObjectMomZ(player.mo, 22*FRACUNIT)
							jumpnuke(player.mo, player.mo, 240*FRACUNIT)
						elseif player.hyper and player.hyper.capable and player.powers[pw_super]
							P_SetObjectMomZ(player.mo, (player.speed / 7) + 25*FRACUNIT)
							jumpnuke(player.mo, player.mo, 500*FRACUNIT)
							S_StartSound(player.mo, sfx_brakrx)
							P_FlashPal(player, PAL_NUKE, 10)
						else
							P_SetObjectMomZ(player.mo, 17*FRACUNIT)
							jumpnuke(player.mo, player.mo, 170*FRACUNIT)
						end
						if (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON //WHAT HAVE YOU DONE
							P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
							P_NukeEnemies(player.mo, player.mo, 900*player.mo.scale)
							P_FlashPal(player, PAL_NUKE, 10)
							player.powers[pw_shield] = SH_NONE
							S_StartSound(player.mo, sfx_bkpoof)
							P_StartQuake(20*FRACUNIT, 5)
							P_InstaThrust(player.mo, player.mo.angle, (10*player.mo.scale + player.speed))
							player.armanuke = 1
						end
						if player.mo.eflags & MFE_UNDERWATER
							player.mo.momz = $*3/5
						end
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						sparks(player.mo, 10 << FRACBITS)
						S_StartSound(player.mo, sfx_dtnbom)
						player.mo.state = S_PLAY_SPRING
					end
				end
				
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z + (P_RandomRange(-3,32)*player.mo.scale),MT_SUPERSPARK)
				if player.hovertime % 3 == 0 
					player.mo.colorized = false
				else
					player.mo.colorized = true
				end
				
				if not player.diddash			
					if player.powers[pw_super]
						player.detspeed = 66*player.mo.scale
					else
						player.detspeed = 58*player.mo.scale
					end
					
					if (player.mo.eflags & MFE_UNDERWATER)
						player.detspeed = $/2
					end
					
					if player.isxmomentum //xmom makes it speed related instead
						player.detspeed = player.speed + 20*player.mo.scale
					end
					
					if (twodlevel or player.mo.flags2 & MF2_TWOD)
						P_InstaThrust(player.mo, player.mo.angle, player.detspeed)
					else 
						P_InstaThrust(player.mo, (player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)),player.detspeed)
					end
					player.diddash = true
				end
			end
			//fall down bitch 
			if not P_IsObjectOnGround(player.mo)
				if player.hovertime == 0 
					if (P_PlayerInPain(player)) return end
					if player.mo.state != S_PLAY_SPRING
						player.mo.state = S_PLAY_ROLL
					end
					player.activatedethover = 0
					player.mo.colorized = false
				end
				
				if player.powers[pw_pushing]
				and not (player.mo.eflags & MFE_SPRUNG)
					if (P_PlayerInPain(player)) return end
					player.mo.state = S_PLAY_ROLL
					P_InstaThrust(player.mo, player.mo.angle, -5*FRACUNIT)
					player.activatedethover = 0
					player.mo.colorized = false
					S_StartSound(player.mo, sfx_s3k9e)
					P_StartQuake(20*FRACUNIT, 5)
					P_SetObjectMomZ(player.mo, 6*FRACUNIT)
				end
			end
			if player.mo.state == (S_PLAY_PAIN or S_PLAY_WALK or S_PLAY_STND)
			or (P_PlayerInPain(player))
			or (player.mo.eflags & MFE_SPRUNG)
				player.activatedethover = 0
				player.hovertime = 0
				player.mo.colorized = false
			end
		end
		
		if player.activatedethover == 0
		and S_SoundPlaying(player.mo, sfx_s3k86) and not (P_PlayerInPain(player)) //bro shut up you're good
			S_StopSoundByID(player.mo, sfx_s3k86)
		end
		
		if player.mo.colorized == true
		and player.hovertime == 30
			player.mo.colorized = false
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.hovnum = 0
			player.hovertime = 30 //how long the hover is
			player.diddash = false
			player.activatedethover = 0
		end			
		
		//making sure things dont get fuckd
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		//reset jumps if carried
		if player.powers[pw_carry]
		or player.powers[pw_carry] == CR_MACESPIN
			player.jumpcheck = 0 
			player.hovnum = 0
			player.hovertime = 30
			player.diddash = false
			player.activatedethover = 0
		end
		
		//self explanatory
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		if (player.pflags & PF_SPINNING)
		and player.mo.state != S_PLAY_ROLL
			player.mo.state = S_PLAY_ROLL
		end
		
		//you too
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) and player.pflags & PF_JUMPED
			player.hovnum = 1
		end	
		
		if Cosmetics
			Cosmetics.SkinOffsets["deton"] = 2
		end
	end
end)

addHook("ShouldDamage", function(mo, mobj)
	if mo and mo.valid 
	and mo.skin == "deton" and mo.player
	and (mo.player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON	
	and mobj and mobj.valid
		mo.player.dothefunny = 1
	end
end, MT_PLAYER)

//poyo boyo,,
if not(kirbyabilitytable) 
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["deton"] = 4